"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.OutlinePaneContext = OutlinePaneContext;
exports.OutlinePlugin = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _notification2 = _interopRequireDefault(require("antd/lib/notification"));
var _pane = require("./views/pane");
var _consts = require("./helper/consts");
var _treeMaster = require("./controllers/tree-master");
var _paneController = require("./controllers/pane-controller");
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function OutlinePaneContext(props) {
  var _notification$useNoti = _notification2["default"].useNotification(),
    api = _notification$useNoti[0],
    contextHolder = _notification$useNoti[1];
  var treeMaster = props.treeMaster || new _treeMaster.TreeMaster(props.pluginContext, props.options, api);
  var _useState = (0, _react.useState)(function () {
      return new _paneController.PaneController(props.paneName || _consts.MasterPaneName, treeMaster);
    }),
    masterPaneController = _useState[0],
    setMasterPaneController = _useState[1];
  (0, _react.useEffect)(function () {
    return treeMaster.onPluginContextChange(function () {
      setMasterPaneController(new _paneController.PaneController(props.paneName || _consts.MasterPaneName, treeMaster));
    });
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_pane.Pane, (0, _extends2["default"])({
    treeMaster: treeMaster,
    controller: masterPaneController,
    key: masterPaneController.id,
    hideFilter: props.hideFilter
  }, props)), contextHolder);
}
var OutlinePlugin = exports.OutlinePlugin = function OutlinePlugin(ctx, options) {
  var skeleton = ctx.skeleton,
    config = ctx.config,
    canvas = ctx.canvas,
    project = ctx.project;
  var isInFloatArea = true;
  var hasPreferenceForOutline = config.getPreference().contains('outline-pane-pinned-status-isFloat', 'skeleton');
  if (hasPreferenceForOutline) {
    isInFloatArea = config.getPreference().get('outline-pane-pinned-status-isFloat', 'skeleton');
  }
  var showingPanes = {
    masterPane: false,
    backupPane: false
  };
  var treeMaster = new _treeMaster.TreeMaster(ctx, options);

  // 点击右侧面板面包屑icon显示大纲树
  var onShowOutlinePanel = function onShowOutlinePanel(e) {
    var target = e.target;
    if ((target === null || target === void 0 ? void 0 : target.getAttribute('class')) == 'lc-settings-navigator-icon') {
      skeleton.showPanel(_consts.BackupPaneName);
    }
  };
  var onClose = function onClose() {
    skeleton.hidePanel(_consts.BackupPaneName);
  };
  return {
    init: function init() {
      return (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var switchPanes;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              // skeleton.add({
              //   area: 'leftArea',
              //   name: 'outlinePane',
              //   type: 'PanelDock',
              //   index: -1,
              //   content: {
              //     name: MasterPaneName,
              //     props: {
              //       icon: IconOutline,
              //       description: treeMaster.pluginContext.intlNode('Outline Tree'),
              //     },
              //     content: OutlinePaneContext,
              //   },
              //   panelProps: {
              //     area: isInFloatArea ? 'leftFloatArea' : 'leftFixedArea',
              //     keepVisibleWhileDragging: true,
              //     ...config.get('defaultOutlinePaneProps'),
              //   },
              //   contentProps: {
              //     treeTitleExtra: config.get('treeTitleExtra'),
              //     treeMaster,
              //     paneName: MasterPaneName,
              //   },
              // });

              skeleton.add({
                area: 'rightArea',
                name: _consts.BackupPaneName,
                type: 'Panel',
                props: {
                  hiddenWhenInit: true
                },
                content: OutlinePaneContext,
                contentProps: {
                  paneName: _consts.BackupPaneName,
                  treeMaster: treeMaster,
                  onClose: onClose
                },
                index: 1
              });

              // 处理 master pane 和 backup pane 切换
              switchPanes = function switchPanes() {
                var _canvas$dragon;
                var isDragging = (_canvas$dragon = canvas.dragon) === null || _canvas$dragon === void 0 ? void 0 : _canvas$dragon.dragging;
                var hasVisibleTreeBoard = showingPanes.backupPane || showingPanes.masterPane;
                var shouldShowBackupPane = isDragging;
                if (shouldShowBackupPane) {
                  skeleton.showPanel(_consts.BackupPaneName);
                } else {
                  skeleton.hidePanel(_consts.BackupPaneName);
                }
              };
              skeleton.onShowPanel(function (key) {
                if (key === _consts.MasterPaneName) {
                  showingPanes.masterPane = true;
                }
                if (key === _consts.BackupPaneName) {
                  showingPanes.backupPane = true;
                }
              });
              skeleton.onHidePanel(function (key) {
                if (key === _consts.MasterPaneName) {
                  showingPanes.masterPane = false;
                  switchPanes();
                }
                if (key === _consts.BackupPaneName) {
                  showingPanes.backupPane = false;
                }
              });
              project.onChangeDocument(function (document) {
                if (!document) {
                  return;
                }
                var selection = document.selection;
                selection === null || selection === void 0 ? void 0 : selection.onSelectionChange(function () {
                  var selectedNodes = selection === null || selection === void 0 ? void 0 : selection.getNodes();
                  if (!selectedNodes || selectedNodes.length === 0) {
                    return;
                  }
                  // skeleton.hidePanel(BackupPaneName);
                  var tree = treeMaster.currentTree;
                  selectedNodes.forEach(function (node) {
                    var treeNode = tree === null || tree === void 0 ? void 0 : tree.getTreeNodeById(node.id);
                    tree === null || tree === void 0 ? void 0 : tree.expandAllAncestors(treeNode);
                  });
                });
              });
              document.addEventListener('click', onShowOutlinePanel);
            case 6:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    destroy: function destroy() {
      document.removeEventListener('click', onShowOutlinePanel);
    }
  };
};
OutlinePlugin.meta = {
  eventPrefix: 'OutlinePlugin',
  preferenceDeclaration: {
    title: '大纲树插件配置',
    properties: [{
      key: 'extraTitle',
      type: 'object',
      description: '副标题'
    }]
  }
};
OutlinePlugin.pluginName = 'OutlinePlugin';