import { PureComponent } from 'react';
import TreeNode from '../controllers/tree-node';
import { IPublicTypeDisposable } from '@gant-lowcode/lowcode-types';
export default class TreeNodeView extends PureComponent<{
    treeNode: TreeNode;
    isModal?: boolean;
    isRootNode?: boolean;
}> {
    state: {
        expanded: boolean;
        selected: boolean;
        hidden: boolean;
        detecting: boolean;
        isRoot: boolean;
        highlight: boolean;
        dropping: boolean;
        conditionFlow: boolean;
        expandable: boolean;
        treeChildren: TreeNode[] | null;
        filterWorking: boolean;
        matchChild: boolean;
        matchSelf: boolean;
    };
    eventOffCallbacks: Array<IPublicTypeDisposable | undefined>;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    shouldShowModalTreeNode(): boolean;
    render(): import("react").JSX.Element;
}
